/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner 
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.1.sql $
$Rev: 10606 $
$Date: 2016-01-27 14:24:30 -0600 (Wed, 27 Jan 2016) $
***************************************************************************************************/
-- Script for installing wvSuite iParts dependencies

print @@servername + ':' + db_name() + ' - starting at ' + convert(varchar(30), getdate(), 109);
print '';
go
set nocount on;
go

-- Silent: repair some renamed configuration items
if exists (select 1 from dbo.SystemConfig where SystemConfigKey = '6E902578-5974-4D0A-BFA0-553493EEF0B5'
	and ParameterName = 'RSM.FindID.DefaultFolder')
begin
	delete dbo.SystemConfigPageParameterRef
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.FindID.DefaultFolder';

	update dbo.PropertyDefinition
		set Label = 'RSM.wvUtility.FindIDFolder'
		where Label = 'RSM.FindID.DefaultFolder'
			and PropertyDefinitionKey = 'F8980069-7BE1-499B-8D82-07914EA45D26';

	update dbo.SystemConfigParameterRef
		set ParameterName = 'RSM.wvUtility.FindIDFolder'
		where ParameterName = 'RSM.FindID.DefaultFolder'
			and PropertyDefinitionKey = 'F8980069-7BE1-499B-8D82-07914EA45D26';

	update dbo.SystemConfig
		set ParameterName = 'RSM.wvUtility.FindIDFolder'
		where ParameterName = 'RSM.FindID.DefaultFolder'
			and SystemConfigKey = '6E902578-5974-4D0A-BFA0-553493EEF0B5';

	insert dbo.SystemConfigPageParameterRef (SystemConfigPageKey, ParameterName, SortOrder)
		values ('316F8E3A-8391-45E4-9005-BC5FDE08EFAC', 'RSM.wvUtility.FindIDFolder', 1002);
end;
go
if exists (select 1 from dbo.SystemConfig where SystemConfigKey = 'EFB84B99-2DC6-49C2-9961-030CFCBCFF03'
	and ParameterName = 'RSM.ActivityEditor.TypesBlacklist')
begin
	delete dbo.SystemConfigPageParameterRef
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.ActivityEditor.TypesBlacklist';

	update dbo.PropertyDefinition
		set Label = 'RSM.wvActivity.TypesBlacklist'
		where Label = 'RSM.ActivityEditor.TypesBlacklist'
			and PropertyDefinitionKey = '32F2DFD6-3FD0-4AAA-B700-60CB93E58F44';

	update dbo.SystemConfigParameterRef
		set ParameterName = 'RSM.wvActivity.TypesBlacklist'
		where ParameterName = 'RSM.ActivityEditor.TypesBlacklist'
			and PropertyDefinitionKey = '32F2DFD6-3FD0-4AAA-B700-60CB93E58F44';

	update dbo.SystemConfig
		set ParameterName = 'RSM.wvActivity.TypesBlacklist'
		where ParameterName = 'RSM.ActivityEditor.TypesBlacklist'
			and SystemConfigKey = 'EFB84B99-2DC6-49C2-9961-030CFCBCFF03';

	insert dbo.SystemConfigPageParameterRef (SystemConfigPageKey, ParameterName, SortOrder)
		values ('316F8E3A-8391-45E4-9005-BC5FDE08EFAC', 'RSM.wvActivity.TypesBlacklist', 1102);
end;
go
if exists (select 1 from dbo.SystemConfig where SystemConfigKey = 'FD65D688-E161-4731-8E40-F0879EFCD316'
	and ParameterName = 'RSM.FileUpload.ExtensionBlacklist')
begin
	delete dbo.SystemConfigPageParameterRef
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.FileUpload.ExtensionBlacklist';

	update dbo.PropertyDefinition
		set Label = 'RSM.wvFileUpload.ExtensionBlacklist'
		where Label = 'RSM.FileUpload.ExtensionBlacklist'
			and PropertyDefinitionKey = '5E0D9A0F-991B-4FC1-B510-FE31CB1C0A9C';

	update dbo.SystemConfigParameterRef
		set ParameterName = 'RSM.wvFileUpload.ExtensionBlacklist'
		where ParameterName = 'RSM.FileUpload.ExtensionBlacklist'
			and PropertyDefinitionKey = '5E0D9A0F-991B-4FC1-B510-FE31CB1C0A9C';

	update dbo.SystemConfig
		set ParameterName = 'RSM.wvFileUpload.ExtensionBlacklist'
		where ParameterName = 'RSM.FileUpload.ExtensionBlacklist'
			and SystemConfigKey = 'FD65D688-E161-4731-8E40-F0879EFCD316';

	insert dbo.SystemConfigPageParameterRef (SystemConfigPageKey, ParameterName, SortOrder)
		values ('316F8E3A-8391-45E4-9005-BC5FDE08EFAC', 'RSM.wvFileUpload.ExtensionBlacklist', 1202);
end;
go


print 'Creating configuration items';
go
if not exists (select 1 from dbo.SystemConfig where SystemConfigKey = 'BF3C2133-F91D-4843-980A-A2F77509CA88')
begin
	print '-- adding RSM.wvUtility.License';

	exec dbo.asi_InsertSystemConfig 'Organization', 'RSMCustomSettings', 'MANAGER',
		'BF3C2133-F91D-4843-980A-A2F77509CA88', 'RSM.wvUtility.License',
		'35DDD081-BBF3-47BD-82F5-A47D8285F92C', 7, 6, 40,
		'License key for wvSuite utility iParts',
		'', 1001;
end
else
begin
	print '-- RSM.wvUtility.License already exists';
	update dbo.SystemConfigPageParameterRef
		set SortOrder = 1001
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.wvUtility.License';
end;
go

if not exists (select 1 from dbo.SystemConfig where SystemConfigKey = '6E902578-5974-4D0A-BFA0-553493EEF0B5')
begin
	print '-- adding RSM.wvUtility.FindIDFolder';

	exec dbo.asi_InsertSystemConfig 'Organization', 'RSMCustomSettings', 'MANAGER',
		'6E902578-5974-4D0A-BFA0-553493EEF0B5', 'RSM.wvUtility.FindIDFolder',
		'F8980069-7BE1-499B-8D82-07914EA45D26', 7, 6, 80,
		'Default folder for FindID searches in wvMultiInstance and wvRelationship',
		'$/ContactManagement/DefaultSystem/Queries/Contacts', 1002;
end
else
begin
	print '-- RSM.wvUtility.FindIDFolder already exists';
	update dbo.SystemConfigPageParameterRef
		set SortOrder = 1002
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.wvUtility.FindIDFolder';;
end;
go



if not exists (select 1 from dbo.SystemConfig where SystemConfigKey = '80613259-948A-4C65-9349-F6E88131CCE2')
begin
	print '-- adding RSM.wvActivity.License';

	exec dbo.asi_InsertSystemConfig 'Organization', 'RSMCustomSettings', 'MANAGER',
		'80613259-948A-4C65-9349-F6E88131CCE2', 'RSM.wvActivity.License',
		'50F4236D-310D-488A-926C-6674B981D66D', 7, 6, 40,
		'License key for wvActivity iPart',
		'', 1101;
end
else
begin
	print '-- RSM.wvActivity.License already exists';
	update dbo.SystemConfigPageParameterRef
		set SortOrder = 1101
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.wvActivity.License';;
end;
go

if not exists (select 1 from dbo.SystemConfig where SystemConfigKey = 'EFB84B99-2DC6-49C2-9961-030CFCBCFF03')
begin
	print '-- adding RSM.wvActivity.TypesBlacklist';

	exec dbo.asi_InsertSystemConfig 'Organization', 'RSMCustomSettings', 'MANAGER',
		'EFB84B99-2DC6-49C2-9961-030CFCBCFF03', 'RSM.wvActivity.TypesBlacklist',
		'32F2DFD6-3FD0-4AAA-B700-60CB93E58F44', 7, 6, 40,
		'Activity types which should never be displayed in ActivityEditor even when keywords permit.',
		'CALL,UPLOAD', 1102;
end
else
begin
	print '-- RSM.wvActivity.TypesBlacklist already exists';
	update dbo.SystemConfigPageParameterRef
		set SortOrder = 1102
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.wvActivity.TypesBlacklist';
end;
go

if not exists (select 1 from dbo.SystemConfig where SystemConfigKey = 'C693C925-ED44-42F9-A61A-1DD5E15E13FD')
begin
	print '-- adding RSM.wvFileUpload.License';

	exec dbo.asi_InsertSystemConfig 'Organization', 'RSMCustomSettings', 'MANAGER',
		'C693C925-ED44-42F9-A61A-1DD5E15E13FD', 'RSM.wvFileUpload.License',
		'983FB9DF-373A-4E72-9944-F5021D306250', 7, 6, 40,
		'License key for wvFileUpload iPart',
		'', 1201;
end
else
begin
	print '-- RSM.wvFileUpload.License already exists';
	update dbo.SystemConfigPageParameterRef
		set SortOrder = 1201
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.wvFileUpload.License';
end;
go

if not exists (select 1 from dbo.SystemConfig where SystemConfigKey = 'FD65D688-E161-4731-8E40-F0879EFCD316')
begin
	print '-- adding RSM.wvFileUpload.ExtensionBlacklist';

	exec dbo.asi_InsertSystemConfig 'Organization', 'RSMCustomSettings', 'MANAGER',
		'FD65D688-E161-4731-8E40-F0879EFCD316', 'RSM.wvFileUpload.ExtensionBlacklist',
		'5E0D9A0F-991B-4FC1-B510-FE31CB1C0A9C', 7, 6, 40,
		'Comma-separated list of file extensions to be rejected by the FileUpload component.',
		'.aspx,.ascx,.asmx,.ashx,.asp,.axd,.cer,.dll,.exe,.config,.master,.php,.cfm,.bat', 1202;;
end
else
begin
	print '-- RSM.wvFileUpload.ExtensionBlacklist already exists';
	update dbo.SystemConfigPageParameterRef
		set SortOrder = 1202
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.wvFileUpload.ExtensionBlacklist';
end;
go

if not exists (select 1 from dbo.SystemConfig where SystemConfigKey = '1771937F-B48F-4A58-B66B-491C30A075F3')
begin
	print '-- adding RSM.wvFileUpload.UploadPath';

	exec dbo.asi_InsertSystemConfig 'Organization', 'RSMCustomSettings', 'MANAGER',
		'1771937F-B48F-4A58-B66B-491C30A075F3', 'RSM.wvFileUpload.UploadPath',
		'BC62EB7E-E5E3-4BE9-B9B5-1EBB7E7BE8ED', 7, 6, 80,
		'Upload path for wvFileUpload iPart',
		'C:\Program Files (x86)\ASI\iMIS15\Net\Download\', 1203;
end
else
begin
	print '-- RSM.wvFileUpload.UploadPath already exists';
	update dbo.SystemConfigPageParameterRef
		set SortOrder = 1203
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.wvFileUpload.UploadPath';
end;
go

if not exists (select 1 from dbo.SystemConfig where SystemConfigKey = 'CDAF118E-AA2F-454B-82D8-05B580D50E4F')
begin
	print '-- adding RSM.wvFileUpload.UploadVirtualPath';

	exec dbo.asi_InsertSystemConfig 'Organization', 'RSMCustomSettings', 'MANAGER',
		'CDAF118E-AA2F-454B-82D8-05B580D50E4F', 'RSM.wvFileUpload.UploadVirtualPath',
		'C94C2A6C-47DC-425B-9C77-B4B205325472', 7, 6, 40,
		'Upload virtual path for wvFileUpload iPart',
		'~/Download/', 1204;
end
else
begin
	print '-- RSM.wvFileUpload.UploadVirtualPath already exists';
	update dbo.SystemConfigPageParameterRef
		set SortOrder = 1204
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.wvFileUpload.UploadVirtualPath';
end;
go

if not exists (select 1 from dbo.SystemConfig where SystemConfigKey = '20870F99-C801-4EAC-AC55-F7EF75791530')
begin
	print '-- adding RSM.wvMultiInstance.License';

	exec dbo.asi_InsertSystemConfig 'Organization', 'RSMCustomSettings', 'MANAGER',
		'20870F99-C801-4EAC-AC55-F7EF75791530', 'RSM.wvMultiInstance.License',
		'C1D614CD-DD08-4EA2-A621-3D272716CB13', 7, 6, 40,
		'License key for wvMultiInstance iParts',
		'', 1301;
end
else
begin
	print '-- RSM.wvMultiInstance.License already exists';
	update dbo.SystemConfigPageParameterRef
		set SortOrder = 1301
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.wvMultiInstance.License';
end;
go

if not exists (select 1 from dbo.SystemConfig where SystemConfigKey = '19CD1A2C-10B8-4C19-854D-81E2473C1BC1')
begin
	print '-- adding RSM.wvMultiInstance.ConfigurationOwner';

	declare @id varchar(10);
	set @id = '2';	-- a likely default for Manager

	-- Choose a _CFG record if there is one
	if exists (select 1 from dbo.Name where MEMBER_TYPE = '_CFG')
	begin
		-- Choose one that has the right member type
		select @id = ID
			from dbo.Name
			where MEMBER_TYPE = '_CFG';
	end;
	
	-- If we already have data and there's only one ID, use that as the best option
	if exists (select 1 from sys.tables where name = 'Config_Custom_Web')
	begin
		if (select count(distinct ID) from dbo.Config_Custom_Web) = 1
		begin
			-- Choose the value in use, if any
			select @id = ID
				from dbo.Config_Custom_Web;
		end;
	end;

	exec dbo.asi_InsertSystemConfig 'Organization', 'RSMCustomSettings', 'MANAGER',
		'19CD1A2C-10B8-4C19-854D-81E2473C1BC1',
		'RSM.wvMultiInstance.ConfigurationOwner',
		'5F94F103-A387-4319-9686-9D7E74FEF388',
		7,
		6,
		40,
		'ID of the contact record which owns the Custom Web Configuration settings',
		@id,
		1302;
end
else
begin
	print '-- RSM.wvMultiInstance.ConfigurationOwner already exists';
	update dbo.SystemConfigPageParameterRef
		set SortOrder = 1302
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.wvMultiInstance.ConfigurationOwner';
end;
go


if not exists (select 1 from dbo.SystemConfig where SystemConfigKey = 'A9DA58AB-5AA6-402A-90F1-E05EEA0B33C9')
begin
	print '-- adding RSM.wvRelationship.License';

	exec dbo.asi_InsertSystemConfig 'Organization', 'RSMCustomSettings', 'MANAGER',
		'A9DA58AB-5AA6-402A-90F1-E05EEA0B33C9', 'RSM.wvRelationship.License',
		'C2FC3211-F8C8-4817-86F0-346DFEAA998E', 7, 6, 40,
		'License key for wvRelationship iPart',
		'', 1401;
end
else
begin
	print '-- RSM.wvRelationship.License already exists';
	update dbo.SystemConfigPageParameterRef
		set SortOrder = 1401
		where SystemConfigPageKey = '316F8E3A-8391-45E4-9005-BC5FDE08EFAC'
			and ParameterName = 'RSM.wvRelationship.License';
end;
go

print 'Removing obsolete configuration items';
go
if exists (select 1 from sys.procedures where name = 'TempDeleteSystemConfigVar')
begin
	exec dbo.TempDeleteSystemConfigVar 'RSM.wvUtility.DefaultCacheDuration';
	exec dbo.TempDeleteSystemConfigVar 'RSM.WriteLog.Filename';
	exec dbo.TempDeleteSystemConfigVar 'RSM.WriteLog.LogLevel';
	exec dbo.TempDeleteSystemConfigVar 'RSM.wvUtility.LogLevel';
end;
go



print 'iMIS configurations';
go
if not exists (select 1 from dbo.Product_Type where PROD_TYPE = 'UPLOAD')
begin
	print '-- adding UPLOAD Activity Type';

	insert dbo.Product_Type (PROD_TYPE, DESCRIPTION, SUBTYPE_PROMPT, DESCRIPTION_PROMPT, SOURCE_PROMPT,
			USER_EDIT, RETAIN_MONTHS, UF_1_PROMPT, UF_2_PROMPT, UF_6_PROMPT, UF_7_PROMPT)
		values('UPLOAD', 'File upload', 'Category', 'Comment', 'Attachment Type',
			1, 12, 'Effective Year', 'Attached File', 'Effective Date', 'Through Date');
end
else
begin
	print '-- UPLOAD Activity Type already exists';
end;
go

if not exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'UPLOAD/CATEGORY')
begin
	print '-- inserting example values for UPLOAD/CATEGORY lookup';

	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
		values ('UPLOAD/CATEGORY', 'MED', 'MED', 'Medical');

	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
		values ('UPLOAD/CATEGORY', 'CERT', 'CERT', 'Certification');
end;

if not exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'UPLOAD/ATTACHMENTTYPE')
begin
	print '-- inserting example values for UPLOAD/ATTACHMENTTYPE';

	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
		values ('UPLOAD/ATTACHMENTTYPE', 'MED.NOTES', 'MED.NOTES', 'Notes');

	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
		values ('UPLOAD/ATTACHMENTTYPE', 'MED.RECORD', 'MED.RECORD', 'Records');

	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
		values ('UPLOAD/ATTACHMENTTYPE', 'MED.OTHER', 'MED.OTHER', 'Other');

	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
		values ('UPLOAD/ATTACHMENTTYPE', 'CERT.OTHER', 'CERT.OTHER', 'Other');

	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
		values ('UPLOAD/ATTACHMENTTYPE', 'CERT.NOTES', 'CERT.NOTES', 'Notes');

	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
		values ('UPLOAD/ATTACHMENTTYPE', 'CERT.CERT', 'CERT.CERT', 'Certificate');
end;
go


if not exists (select 1 from dbo.Member_Types where MEMBER_TYPE = '_CFG')
begin
	print '-- inserting _CFG member type as owner of configurations';

	insert dbo.Member_Types (MEMBER_TYPE, DESCRIPTION)
		values ('_CFG', '_Configuration');
end;
go

print 'Creating table Config_Custom_Web';
go
if object_id('Config_Custom_Web') is not NULL
begin
	if (select rows from dbo.sysindexes where id = object_id('Config_Custom_Web') and indid < 2) > 0
	begin
		print '***Not deleting - data exists';
	end
	else
	begin
		drop table dbo.Config_Custom_Web;
	end;
end;
go
if object_id('Config_Custom_Web') is NULL
begin
	create table dbo.Config_Custom_Web
	(
		ID varchar(10) not NULL default '',
		SEQN int not NULL default 0,
		DEMOG_TABLE_NAME varchar(30) not NULL default '',
		FIELD_NAME varchar(50) not NULL default '',
		FIELD_REQUIRED bit not NULL default 0,
		DESCRIPTION_BEFORE varchar(2048) NULL,
		DESCRIPTION_AFTER varchar(2048) NULL,
		PAGEPART varchar(30) not NULL default '',
		PROMPT varchar(255) not NULL default '',
		SHOW_IN_GRID bit not NULL default 0,
		SORT_POSITION int not NULL default 0,
		ROLES_REQUIRED_EDIT varchar(255) not NULL default '',
		ROLES_REQUIRED_VIEW varchar(255) not NULL default '',
		TOOLTIP varchar(255) not NULL default '',
		VALIDATION_TABLE varchar(255) not NULL default '',
		VALIDATION_TYPE varchar(30) not NULL default '',
		CUSTOM_CSS varchar(100) not NULL default '',
		ROLES_REQUIRED_EDIT_NEW varchar(255) not NULL default '',
		ROLES_REQUIRED_VIEW_NEW varchar(255) not NULL default '',
		DEFAULT_VALUE_FUNCTION varchar(100) not NULL default '',
		TIME_STAMP timestamp NULL
	);
end;
go
if object_id('PK_Config_Custom_Web') is NULL
begin
	alter table dbo.Config_Custom_Web
		add constraint PK_Config_Custom_Web
		primary key clustered (ID, SEQN);
end;
go
grant select, insert, update, delete, references, view definition on dbo.Config_Custom_Web to IMIS;
grant select on dbo.Config_Custom_Web to public;
go

if not exists (select 1 from dbo.UD_Table where TABLE_NAME = 'Config_Custom_Web')
begin
	print '-- Adding definition of Config_Custom_Web'

	-- Insert rows in UD_Table
	insert dbo.UD_Table (TABLE_NAME, DESCRIPTION, APPLICATION, EXTERNAL_FLAG, LINK_VIA, ALLOW_MULTIPLE_INSTANCES, REQUIRED, EDIT_TYPES, NAME_ALL_TABLE) values ('Config_Custom_Web', '', 'Membership', 0, 'ID', 1, 0, '_CFG', 0);

	-- Insert rows in UD_Field
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (1, 'Config_Custom_Web', 'DEMOG_TABLE_NAME', 'Char', 30, 0, '', 'CCW_MULTI_UDTS', 0, '', '', '', 13, 150, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (2, 'Config_Custom_Web', 'FIELD_NAME', 'Char', 50, 0, '', '', 0, '', '', '', 13, 150, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (3, 'Config_Custom_Web', 'FIELD_REQUIRED', 'CheckBox', 0, 0, '', '', 0, '', '', '', 13, 135, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (4, 'Config_Custom_Web', 'CUSTOM_CSS', 'Char', 100, 0, 'Custom CSS', '', 0, '', '', '', 13, 150, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (5, 'Config_Custom_Web', 'DESCRIPTION_BEFORE', 'Char', 2048, 0, '', '', 0, '', '', '', 30, 300, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (6, 'Config_Custom_Web', 'DESCRIPTION_AFTER', 'Char', 2048, 0, '', '', 0, '', '', '', 30, 300, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (7, 'Config_Custom_Web', 'PAGEPART', 'Char', 30, 0, '', 'CCW_PAGEPART', 0, '', '', '', 13, 150, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (8, 'Config_Custom_Web', 'PROMPT', 'Char', 255, 0, '', '', 0, '', '', '', 30, 300, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (9, 'Config_Custom_Web', 'SHOW_IN_GRID', 'CheckBox', 0, 0, 'Show in Grid', '', 0, '', '', '', 13, 135, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (10, 'Config_Custom_Web', 'SORT_POSITION', 'Int', 0, 0, 'Sort position', '', 0, '', '', '', 13, 80, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (11, 'Config_Custom_Web', 'ROLES_REQUIRED_EDIT', 'Char', 255, 0, 'Role(s) required to edit', 'CCW_ROLES_REQUIRED', 1, '', '', '', 30, 300, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (12, 'Config_Custom_Web', 'ROLES_REQUIRED_EDIT_NEW', 'Char', 255, 0, 'Role(s) required to edit when', 'CCW_ROLES_REQUIRED', 1, '', '', '', 30, 300, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (13, 'Config_Custom_Web', 'ROLES_REQUIRED_VIEW', 'Char', 255, 0, 'Role(s) required to view', 'CCW_ROLES_REQUIRED', 1, '', '', '', 30, 300, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (14, 'Config_Custom_Web', 'ROLES_REQUIRED_VIEW_NEW', 'Char', 255, 0, 'Role(s) required to view when', 'CCW_ROLES_REQUIRED', 1, '', '', '', 30, 300, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (15, 'Config_Custom_Web', 'TOOLTIP', 'Char', 255, 0, '', '', 0, '', '', '', 30, 300, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (16, 'Config_Custom_Web', 'VALIDATION_TABLE', 'Char', 255, 0, '', '', 0, '', '', '', 30, 300, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (17, 'Config_Custom_Web', 'VALIDATION_TYPE', 'Char', 30, 0, '', 'CCW_VALIDATION_TYPE', 0, '', '', '', 13, 150, 0, 0, '');
	insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (18, 'Config_Custom_Web', 'DEFAULT_VALUE_FUNCTION', 'Char', 100, 0, 'Function for default value', '', 0, '', '', '', 13, 150, 0, 0, '');

	-- Insert rows in UD_WindowHeader
	insert dbo.UD_WindowHeader (APPLICATION, WINDOW_NAME, ACCESS_KEYWORDS, SEQ, TITLE, TABLE_NAME, AUTO_CREATE, WINDOW_HEIGHT, WINDOW_WIDTH, USE_VERTICAL_SCROLL, NUM_OF_COLUMNS) values ('Membership', 'Name-Custom Web Setup', '', 0, 'Custom Web Setup', 'Config_Custom_Web', 0, 230, 450, 1, 1);

	-- Insert rows in UD_WindowFields
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (1, 'Name-Custom Web Setup', 'Config_Custom_Web', 'DEMOG_TABLE_NAME', 'Config_Custom_Web.DEMOG_TABLE_NAME', 10, 5, '', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (2, 'Name-Custom Web Setup', 'Config_Custom_Web', 'FIELD_NAME', 'Config_Custom_Web.FIELD_NAME', 10, 250, '', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (3, 'Name-Custom Web Setup', 'Config_Custom_Web', 'PAGEPART', 'Config_Custom_Web.PAGEPART', 10, 495, '', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (4, 'Name-Custom Web Setup', 'Config_Custom_Web', 'PROMPT', 'Config_Custom_Web.PROMPT', 10, 740, '', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (5, 'Name-Custom Web Setup', 'Config_Custom_Web', 'CUSTOM_CSS', 'Config_Custom_Web.CUSTOM_CSS', 10, 5, 'Custom CSS', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (6, 'Name-Custom Web Setup', 'Config_Custom_Web', 'SORT_POSITION', 'Config_Custom_Web.SORT_POSITION', 10, 250, '', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (7, 'Name-Custom Web Setup', 'Config_Custom_Web', 'VALIDATION_TABLE', 'Config_Custom_Web.VALIDATION_TABLE', 27, 5, '', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (8, 'Name-Custom Web Setup', 'Config_Custom_Web', 'VALIDATION_TYPE', 'Config_Custom_Web.VALIDATION_TYPE', 61, 5, '', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (9, 'Name-Custom Web Setup', 'Config_Custom_Web', 'DEFAULT_VALUE_FUNCTION', 'Config_Custom_Web.DEFAULT_VALUE_FUNCTION', 61, 250, 'Function for default value', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (10, 'Name-Custom Web Setup', 'Config_Custom_Web', 'FIELD_REQUIRED', 'Config_Custom_Web.FIELD_REQUIRED', 78, 5, '', 0, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (11, 'Name-Custom Web Setup', 'Config_Custom_Web', 'DESCRIPTION_BEFORE', 'Config_Custom_Web.DESCRIPTION_BEFORE', 95, 5, '', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (12, 'Name-Custom Web Setup', 'Config_Custom_Web', 'DESCRIPTION_AFTER', 'Config_Custom_Web.DESCRIPTION_AFTER', 129, 5, '', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (13, 'Name-Custom Web Setup', 'Config_Custom_Web', 'TOOLTIP', 'Config_Custom_Web.TOOLTIP', 163, 5, '', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (14, 'Name-Custom Web Setup', 'Config_Custom_Web', 'ROLES_REQUIRED_EDIT', 'Config_Custom_Web.ROLES_REQUIRED_EDIT', 197, 5, 'Role(s) required for edit', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (15, 'Name-Custom Web Setup', 'Config_Custom_Web', 'ROLES_REQUIRED_EDIT_NEW', 'Config_Custom_Web.ROLES_REQUIRED_EDIT_NEW', 197, 400, 'Role(s) required to edit new', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (16, 'Name-Custom Web Setup', 'Config_Custom_Web', 'ROLES_REQUIRED_VIEW', 'Config_Custom_Web.ROLES_REQUIRED_VIEW', 231, 5, 'Role(s) required for view', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (17, 'Name-Custom Web Setup', 'Config_Custom_Web', 'ROLES_REQUIRED_VIEW_NEW', 'Config_Custom_Web.ROLES_REQUIRED_VIEW_NEW', 231, 400, 'Role(s) required to view new', 85, 0, 0, 0);
	insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (18, 'Name-Custom Web Setup', 'Config_Custom_Web', 'SHOW_IN_GRID', 'Config_Custom_Web.SHOW_IN_GRID', 265, 5, 'Show in Grid', 0, 0, 0, 0);
end
else
begin
	-- Update CCW with the new _CFG record if necessary
	/*
	update dbo.Config_Custom_Web
		set ID = '17437'
		where ID = '4'
	*/

	-- Rename windows to match generic wvSuite
/*
	update dbo.dbo.UD_WindowHeader
		set WINDOW_NAME = 'Name-Custom Web Setup'
		where WINDOW_NAME = 'Name-Config_Custom_Web'
	update dbo.dbo.UD_WindowFields
		set WINDOW_NAME = 'Name-Custom Web Setup'
		where WINDOW_NAME = 'Name-Config_Custom_Web'
*/

	print '-- Adding columns to Config_Custom_Web';
	declare @nextfseq int,
		@nextwseq int;

	select @nextfseq = isnull(max(SEQ),0) + 1
		from dbo.UD_Field
		where TABLE_NAME = 'Config_Custom_Web';
	select @nextwseq = isnull(max(SEQ),0) + 1
		from dbo.UD_WindowFields
		where TABLE_NAME = 'Config_Custom_Web';

	if not exists (select 1 from dbo.UD_Field where TABLE_NAME = 'Config_Custom_Web' and FIELD_NAME = 'CUSTOM_CSS')
	begin
		insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (@nextfseq, 'Config_Custom_Web', 'CUSTOM_CSS', 'Char', 100, 0, 'Custom CSS', '', 0, '', '', '', 13, 150, 0, 0, '');
		set @nextfseq = @nextfseq + 1;
		alter table dbo.Config_Custom_Web
			add CUSTOM_CSS varchar(100) not NULL default '';
	end;
	if not exists (select 1 from dbo.UD_WindowFields where TABLE_NAME = 'Config_Custom_Web' and FIELD_NAME = 'CUSTOM_CSS')
	begin
		insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (@nextwseq, 'Name-Custom Web Setup', 'Config_Custom_Web', 'CUSTOM_CSS', 'Config_Custom_Web.CUSTOM_CSS', 10, 5, 'Custom CSS', 85, 0, 0, 0);
		set @nextwseq = @nextwseq + 1;
	end;

	if not exists (select 1 from dbo.UD_Field where TABLE_NAME = 'Config_Custom_Web' and FIELD_NAME = 'ROLES_REQUIRED_EDIT_NEW')
	begin
		insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (@nextfseq, 'Config_Custom_Web', 'ROLES_REQUIRED_EDIT_NEW', 'Char', 255, 0, 'Role(s) required to edit new', 'CCW_ROLES_REQUIRED', 1, '', '', '', 30, 300, 0, 0, '');
		set @nextfseq = @nextfseq + 1;
		alter table dbo.Config_Custom_Web
			add ROLES_REQUIRED_EDIT_NEW varchar(255) not NULL default '';
	end;
	if not exists (select 1 from dbo.UD_WindowFields where TABLE_NAME = 'Config_Custom_Web' and FIELD_NAME = 'ROLES_REQUIRED_EDIT_NEW')
	begin
		insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (@nextwseq, 'Name-Custom Web Setup', 'Config_Custom_Web', 'ROLES_REQUIRED_EDIT_NEW', 'Config_Custom_Web.ROLES_REQUIRED_EDIT_NEW', 197, 400, 'Role(s) required to edit new', 85, 0, 0, 0);
		set @nextwseq = @nextwseq + 1;
	end;

	if not exists (select 1 from dbo.UD_Field where TABLE_NAME = 'Config_Custom_Web' and FIELD_NAME = 'ROLES_REQUIRED_VIEW_NEW')
	begin
		insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (@nextfseq, 'Config_Custom_Web', 'ROLES_REQUIRED_VIEW_NEW', 'Char', 255, 0, 'Role(s) required to view new', 'CCW_ROLES_REQUIRED', 1, '', '', '', 30, 300, 0, 0, '');
		set @nextfseq = @nextfseq + 1;
		alter table Config_Custom_Web
			add ROLES_REQUIRED_VIEW_NEW varchar(255) not NULL default '';
	end;
	if not exists (select 1 from dbo.UD_WindowFields where TABLE_NAME = 'Config_Custom_Web' and FIELD_NAME = 'ROLES_REQUIRED_VIEW_NEW')
	begin
		insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (@nextwseq, 'Name-Custom Web Setup', 'Config_Custom_Web', 'ROLES_REQUIRED_VIEW_NEW', 'Config_Custom_Web.ROLES_REQUIRED_VIEW_NEW', 197, 400, 'Role(s) required to view new', 85, 0, 0, 0);
		set @nextwseq = @nextwseq + 1;
	end;

	if not exists (select 1 from dbo.UD_Field where TABLE_NAME = 'Config_Custom_Web' and FIELD_NAME = 'DEFAULT_VALUE_FUNCTION')
	begin
		insert dbo.UD_Field (SEQ, TABLE_NAME, FIELD_NAME, FIELD_TYPE, FIELD_LENGTH, DECIMAL_POSITIONS, PROMPT, VALIDATION_TABLE, MULTI_SELECT, MICRO_HELP, OLD_FIELD_NAME, FORMAT_MASK, OBJ_HEIGHT, OBJ_WIDTH, PROMPT_WIDTH, AUTO_CONVERSION, DEFAULT_VALUE) values (@nextfseq, 'Config_Custom_Web', 'DEFAULT_VALUE_FUNCTION', 'Char', 100, 0, 'Function for default value', '', 0, '', '', '', 13, 150, 0, 0, '');
		set @nextfseq = @nextfseq + 1;
		alter table Config_Custom_Web
			add DEFAULT_VALUE_FUNCTION varchar(100) not NULL default '';
	end;
	if not exists (select 1 from dbo.UD_WindowFields where TABLE_NAME = 'Config_Custom_Web' and FIELD_NAME = 'DEFAULT_VALUE_FUNCTION')
	begin
		insert dbo.UD_WindowFields (SEQ, WINDOW_NAME, TABLE_NAME, FIELD_NAME, TABLE_FIELD_NAME, VERTICAL_POSITION, HORIZONTAL_POSITION, PROMPT, PROMPT_WIDTH, READ_ONLY, NEW_ROW, SHOW_ON_PROFILE) values (@nextwseq, 'Name-Custom Web Setup', 'Config_Custom_Web', 'DEFAULT_VALUE_FUNCTION', 'Config_Custom_Web.DEFAULT_VALUE_FUNCTION', 61, 250, 'Function for default value', 85, 0, 0, 0);
		set @nextwseq = @nextwseq + 1;
	end;
end;
go

if not exists (select 1 from sys.tables where name = 'Config_Custom_Web')
	or exists (select 1 from sys.columns where object_name(object_id) = 'Config_Custom_Web' and name = 'MODE')
	or not exists (select 1 from sys.columns where object_name(object_id) = 'Config_Custom_Web' and name = 'DEFAULT_VALUE_FUNCTION')
begin
	print '*** NOTE: wvMultiInstance will not work with iMIS desktop until you complete the following steps:';
	print '***     1. Log into iMIS desktop as MANAGER';
	print '***     2. Go to Customer > Module Setup > Custom Tables';
	print '***     3. Edit and save the Config_Custom_Web table';
	print '***     4. Edit and save the Name-Custom Web Setup window';
	print '***     5. Regenerate the Business Objects for User Defined Tables';
end;
go


-- Table exists - may need to rename MODE field and reassign some lookups

if exists (select 1 from dbo.UD_Field where TABLE_NAME = 'Config_Custom_Web' and FIELD_NAME = 'MODE')
begin
	update dbo.UD_Field
		set FIELD_NAME = 'PAGEPART',
			VALIDATION_TABLE = 'CCW_PAGEPART'
		where TABLE_NAME = 'Config_Custom_Web'
			and FIELD_NAME = 'MODE';

	update dbo.UD_WindowFields
		set FIELD_NAME = 'PAGEPART',
			TABLE_FIELD_NAME = 'Config_Custom_Web.PAGEPART'
		where TABLE_FIELD_NAME = 'Config_Custom_Web.MODE';

	exec dbo.sp_rename 'Config_Custom_Web.MODE', 'PAGEPART', 'COLUMN';
end;
go

-- update other lookups
update dbo.UD_Field
	set VALIDATION_TABLE = 'CCW_MULTI_UDTS'
	where TABLE_NAME = 'Config_Custom_Web'
		and FIELD_NAME = 'DEMOG_TABLE_NAME'
		and VALIDATION_TABLE = 'DEMOG_TABLE_NAME';

update dbo.UD_Field
	set VALIDATION_TABLE = 'CCW_ROLES_REQUIRED'
	where TABLE_NAME = 'Config_Custom_Web'
		and FIELD_NAME in ('ROLES_REQUIRED_EDIT', 'ROLES_REQUIRED_VIEW')
		and VALIDATION_TABLE = 'ROLES_REQUIRED';

update dbo.UD_Field
	set VALIDATION_TABLE = 'CCW_VALIDATION_TYPE'
	where TABLE_NAME = 'Config_Custom_Web'
		and FIELD_NAME = 'VALIDATION_TYPE'
		and VALIDATION_TABLE = 'VALIDATION_TYPE';

go

if not exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'CCW_MULTI_UDTS')
begin
	if exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'DEMOG_TABLE_NAME')
	begin
		print '-- renaming DEMOG_TABLE_NAME lookup as CCW_MULTI_UDTS';

		update dbo.Gen_Tables
			set TABLE_NAME = 'CCW_MULTI_UDTS'
			where TABLE_NAME = 'DEMOG_TABLE_NAME';
	end
end;
go

print '-- Adding MI UD tables to CCW_MULTI_UDTS lookup';

insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
	select 'CCW_MULTI_UDTS', udt.TABLE_NAME, upper(udt.TABLE_NAME), udt.TABLE_NAME
	from dbo.UD_Table udt
	where ALLOW_MULTIPLE_INSTANCES = 1
		and udt.TABLE_NAME not in (select CODE from dbo.Gen_Tables where TABLE_NAME = 'CCW_MULTI_UDTS');
go


if not exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'CCW_PAGEPART')
begin
	if exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'MODE')
	begin
		print '-- renaming MODE lookup as CCW_PAGEPART';

		update dbo.Gen_Tables
			set TABLE_NAME = 'CCW_PAGEPART'
			where TABLE_NAME = 'MODE';
	end
	else
	begin
		print '-- Adding example to CCW_PAGEPART lookup';

		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
			values ('CCW_PAGEPART', 'PAGE.PART', 'PAGE.PART', 'Example. Choose a PAGE for each wvMultiInstance page and a unique PART for each section on that page.');
	end;
end;
go

if not exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'CCW_ROLES_REQUIRED')
begin
	if exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'ROLES_REQUIRED')
	begin
		print '-- renaming ROLES_REQUIRED lookup as CCW_ROLES_REQUIRED';

		update dbo.Gen_Tables
			set TABLE_NAME = 'CCW_ROLES_REQUIRED'
			where TABLE_NAME = 'ROLES_REQUIRED';
	end
	else
	begin
		print '-- Adding example to CCW_ROLES_REQUIRED lookup';

		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION)
			values ('CCW_ROLES_REQUIRED', 'PRIVILEGED', 'PRIVILEGED', '', 'Users who can edit after a record is submitted');
		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION)
			values ('CCW_ROLES_REQUIRED', 'NOBODY', 'NOBODY', '', 'Assign only to securables, never to users');
	end;
end;
go

if not exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'CCW_PAGEPRIMARYTABLE')
begin
	if exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'RSMX_CCW_MODEPRIMARYTABLE')
	begin
		print '-- Renaming RSMX_CCW_MODEPRIMARYTABLE lookup as CCW_PAGEPRIMARYTABLE';

		update dbo.Gen_Tables
			set TABLE_NAME = 'CCW_PAGEPRIMARYTABLE'
			where TABLE_NAME = 'RSMX_CCW_MODEPRIMARYTABLE';
	end
	else
	begin
		print '-- Adding example to Gen_Tables CCW_PAGEPRIMARYTABLE';

		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE)
			values ('CCW_PAGEPRIMARYTABLE', 'EX', 'EX', 'UD_Example');
	end;
end
else
begin
	print '-- Gen_Tables CCW_PAGEPRIMARYTABLE already exists';
end;


if not exists (select 1 from dbo.RoleMain where RoleKey = '061951A1-23F4-4731-BB15-4307BCE18261')
begin
	print '-- Adding Privileged role';

	insert dbo.RoleMain (Description, IsSystem, Name, RoleKey, UpdatedByUserKey, UpdatedOn)
		select N'Permitted to edit wvMultiInstance pages when lookup CCW_SUBMISSION_STATUS_ACCESS blocks most users',
			0,
			N'Privileged',
			'061951A1-23F4-4731-BB15-4307BCE18261',
			um.UserKey,
			getdate()
		from dbo.UserMain um
		where um.UserId = 'MANAGER'
			and not exists (select 1 from dbo.RoleMain where RoleKey = '061951A1-23F4-4731-BB15-4307BCE18261');
end
else
begin
	print '-- Privileged role already exists';
end;


if not exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'SUBMISSION_STATUS')
begin
	print 'Adding example to SUBMISSION_STATUS lookup';

	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION)
		values ('SUBMISSION_STATUS', '10PENDING', '10PENDING', '', 'Pending Information');
	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION)
		values ('SUBMISSION_STATUS', '20READY', '20READY', '', 'Ready for Review');
	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION)
		values ('SUBMISSION_STATUS', '90CLOSED', '90CLOSED', '', 'Closed');
end;
go

if not exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'CCW_SUBMISSION_STATUS_ACCESS')
begin
	if exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'SUBMISSION_STATUS_ACCESS')
	begin
		print '-- renaming SUBMISSION_STATUS_ACCESS as CCW_SUBMISSION_STATUS_ACCESS';

		update dbo.Gen_Tables
			set TABLE_NAME = 'CCW_SUBMISSION_STATUS_ACCESS'
			where TABLE_NAME = 'SUBMISSION_STATUS_ACCESS';
	end
	else
	begin
		print 'Adding example to CCW_SUBMISSION_STATUS_ACCESS lookup';

		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION)
			values ('CCW_SUBMISSION_STATUS_ACCESS', '10PENDING', '10PENDING', 'Edit', 'Edit');
		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION)
			values ('CCW_SUBMISSION_STATUS_ACCESS', '20READY', '20READY', 'View', 'Edit');
		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION)
			values ('CCW_SUBMISSION_STATUS_ACCESS', '90CLOSED', '90CLOSED', 'View', 'View');
	end;
end;
go


if not exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'CCW_VALIDATION_TYPE')
begin
	if exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'VALIDATION_TYPE')
	begin
		print '-- renaming VALIDATION_TYPE as CCW_VALIDATION_TYPE';

		update dbo.Gen_Tables
			set TABLE_NAME = 'CCW_VALIDATION_TYPE'
			where TABLE_NAME = 'VALIDATION_TYPE';
	end
	else
	begin
		print '-- Populating CCW_VALIDATION_TYPE lookup';

		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION)
			values ('CCW_VALIDATION_TYPE', '', '', '', 'Blank');
		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION)
			values ('CCW_VALIDATION_TYPE', 'FINDID', 'FINDID', '', 'Find ID');
		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION)
			values ('CCW_VALIDATION_TYPE', 'GENTABLE', 'GENTABLE', '', 'General Lookup Tables');
		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION)
			values ('CCW_VALIDATION_TYPE', 'SQLFUNCTION', 'SQLFUNCTION', '', 'Calculated (SQL)');
	end;
end
go

if exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'CCW_VALIDATION_TYPE' and CODE = 'FIND_ID')
begin
	update dbo.Gen_Tables
		set CODE = 'FINDID',
			UPPER_CODE = 'FINDID',
			DESCRIPTION = 'Find ID'
		where TABLE_NAME = 'CCW_VALIDATION_TYPE'
			and CODE = 'FIND_ID';
	
	update dbo.Config_Custom_Web
		set VALIDATION_TYPE = 'FINDID'
		where VALIDATION_TYPE = 'FIND_ID'
end
go


go
print 'Creating table tr_wv_Log';
go
if object_id('tr_wv_Log') is not NULL
begin
	if (select rows from dbo.sysindexes where id = object_id('tr_wv_Log') and indid < 2) > 0
	begin
		print '***Not deleting - data exists';
	end
	else
	begin
		drop table dbo.tr_wv_Log;
	end;
end;
go
if object_id('tr_wv_Log') is NULL
begin
	create table dbo.tr_wv_Log
	(
		SEQN int identity,
		CONFIG_LOG_LEVEL int not null default 0,
		CURRENT_LOG_LEVEL int not null default 0,
		DATE_ADDED datetime not null default getdate(),
		LOG_TEXT nvarchar(4000) not null default ''
	);
end;
go
if object_id('pkr_wv_Log') is NULL
begin
	alter table dbo.tr_wv_Log
		add constraint pkr_wv_Log
		primary key clustered (SEQN);
end;
go
grant select, insert, update, delete, references, view definition on dbo.tr_wv_Log to IMIS;
grant select on dbo.tr_wv_Log to public;
go

print 'Creating table tr_wv_SelectorDetail';
go
if object_id('tr_wv_SelectorDetail') is not NULL
begin
	if (select rows from dbo.sysindexes where id = object_id('tr_wv_SelectorDetail') and indid < 2) > 0
	begin
		print '***Not deleting - data exists';
	end
	else
	begin
		drop table dbo.tr_wv_SelectorDetail;
	end;
end;
go
if object_id('tr_wv_SelectorDetail') is NULL
begin
	create table dbo.tr_wv_SelectorDetail
	(
		DETAIL_KEY uniqueidentifier not null default '',
		PAGE_KEY int not null default 0,
		PAGE_CODE nvarchar(30) not null default '',
		DATE_ADDED datetime not null default getdate()
	);
end;
go
if object_id('pkr_wv_SelectorDetail') is NULL
begin
	alter table dbo.tr_wv_SelectorDetail
		add constraint pkr_wv_SelectorDetail
		primary key clustered (DETAIL_KEY);
end;
go
if not exists (select 1 from dbo.sysindexes where id = object_id('tr_wv_SelectorDetail')
		and name = 'ir_wv_SelectorDetailPAGE_KEY')
begin
	create index ir_wv_SelectorDetailPAGE_KEY
		on dbo.tr_wv_SelectorDetail(PAGE_KEY);
end;
go
grant select, insert, update, delete, references, view definition on dbo.tr_wv_SelectorDetail to IMIS;
grant select on dbo.tr_wv_SelectorDetail to public;
go


print 'Installing SQLCLR components';
go
print '-- Enabling CLR integration';
go
declare @lightweight int;
select @lightweight = convert(int, value)
	from sys.configurations
	where name = 'lightweight pooling';

if @lightweight = 1
begin
	print '!! CLR Integration requires disabling lightweight pooling.';
	print '!! Please disable lightweight pooling and restart SQL to proceed.';
end
else
begin
	declare @clr int, @rv sql_variant;
	select @clr = convert(int, value)
		from sys.configurations
		where name = 'clr enabled';

	if @clr = 0
	begin
		exec @rv = dbo.sp_configure 'clr enabled', 1;
		if convert(int, @rv) = 0
		begin
			reconfigure;
			print '-- CLR integration enabled';
		end
		else
		begin
			print '!! error enabling CLR integration';
		end;
	end
	else
	begin
		print '-- CLR integration already enabled';
	end;
end;
go

if exists (select 1 from sys.assemblies where name = 'RSMSQLCLR')
begin
	print '-- removing RSMSQLCLR assembly';

	if object_id('fr_wv_SeqnToSelector') is not NULL
	begin
		drop function dbo.fr_wv_SeqnToSelector;
	end;

	if object_id('fr_wv_SelectorToSeqn') is not NULL
	begin
		drop function dbo.fr_wv_SelectorToSeqn;
	end;

	if object_id('fr_wv_PageAccessMode') is not NULL
	begin
		drop function dbo.fr_wv_PageAccessMode;
	end;

	if object_id('fr_wv_AssemblyInformation') is not NULL
	begin
		drop function dbo.fr_wv_AssemblyInformation;
	end;

	if object_id('pr_DE_CreateInstance') is not NULL
	begin
		drop procedure dbo.pr_DE_CreateInstance;
	end;

	if object_id('pr_DE_CreateMultiInstance') is not NULL
	begin
		drop procedure dbo.pr_DE_CreateMultiInstance;
	end;

	if object_id('fr_DE_SeqnToSelector') is not NULL
	begin
		drop function dbo.fr_DE_SeqnToSelector;
	end;

	if object_id('fr_DE_PageAccessMode') is not NULL
	begin
		drop function dbo.fr_DE_PageAccessMode;
	end;

	drop assembly RSMSQLCLR;
end;
go

go
print '';
print @@servername + ':' + db_name() + ' - finished at ' + convert(varchar(30), getdate(), 109);
print '';
go