/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
-- Procedures, functions, views, including CLR functions

print @@servername + ':' + db_name() + ' - starting at ' + convert(varchar(30), getdate(), 109);
print '';
go
set nocount on;
go

print '-- fr_wv_SeqnToSelector';
go
create function fr_wv_SeqnToSelector
	(@seqn int, @pagePart nvarchar(30))
	returns nvarchar(50)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
external name RSMSQLCLR.UserDefinedFunctions.fr_wv_SeqnToSelector;
go
grant execute, references, view definition on dbo.fr_wv_SeqnToSelector to IMIS;
go

print '-- fr_wv_SelectorToSeqn';
go
create function fr_wv_SelectorToSeqn
	(@selector nvarchar(50), @pagePart nvarchar(30), @imisId nvarchar(10))
	returns int
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
external name RSMSQLCLR.UserDefinedFunctions.fr_wv_SelectorToSeqn;
go
grant execute, references, view definition on dbo.fr_wv_SelectorToSeqn to IMIS;
go

print '-- fr_wv_AssemblyInformation';
go
create function fr_wv_AssemblyInformation
	()
	returns nvarchar(255)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
external name RSMSQLCLR.UserDefinedFunctions.AssemblyInformation;
go
grant execute, references, view definition on dbo.fr_wv_AssemblyInformation to IMIS;
go





print 'Creating Transact-SQL objects';
go

print '-- fr_ListToRows';
go
if object_id('fr_ListToRows') is not NULL
begin
	drop function fr_ListToRows;
end;
go
create function fr_ListToRows
	(@sCommaString varchar(8000))
	returns @tReturn table (VALUE varchar(255))
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	declare @sValue varchar(255),
		@lPos int;

	while @sCommaString > ''
	begin
		set @lPos = charindex(',', @sCommaString);

		if @lPos > 0
		begin
			set @sValue = substring(@sCommaString, 1, @lPos - 1);
			set @sCommaString = substring(@sCommaString, @lPos + 1, len(@sCommaString));
		end
		else
		begin
			set @sValue = @sCommaString;
			set @sCommaString = '';
		end;

		if not exists (select 1 from @tReturn where VALUE = @sValue)
		begin
			insert @tReturn (VALUE)
				values (@sValue);
		end;
	end;

	return;
end;
go
grant select on dbo.fr_ListToRows to public;
go


print '-- fr_BeforeDelimiter';
go
if object_id('fr_BeforeDelimiter') is not NULL
begin
	drop function fr_BeforeDelimiter;
end;
go
create function fr_BeforeDelimiter(@sString varchar(255), @sDelimiter char(1)) returns varchar(255)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	declare @sReturn as varchar(255),
		@lPos as int;

	set @lPos = charindex(@sDelimiter, @sString);
	if @lPos > 0
	begin
		set @sReturn = left(@sString, @lPos - 1);
	end
	else
	begin
		set @sReturn = @sString;
	end;

	return @sReturn;
end;
go
grant execute on dbo.fr_BeforeDelimiter to public;
go


if object_id('fr_wv_UserCanEditRecord') is not NULL
begin
	print '-- Deleting obsolete fr_wv_UserCanEditRecord';
	drop function fr_wv_UserCanEditRecord;
end;
go


print '-- fr_CCWCalc_TemporaryPlaceholder';
go
if object_id('fr_CCWCalc_TemporaryPlaceholder') is not NULL
begin
	drop function fr_CCWCalc_TemporaryPlaceholder;
end;
go
create function fr_CCWCalc_TemporaryPlaceholder	(@plSeqn int)
	returns int
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
-- This function is a placeholder until the appropriate function is written
begin
	declare @lReturn int;

	set @lReturn = -2000000000;

	return @lReturn;
end;
go
grant execute, references, view definition on fr_CCWCalc_TemporaryPlaceholder to IMIS;
go

print 'Creating function fr_wv_PagePrimaryTable';
go
if object_id('fr_wv_PagePrimaryTable') is not NULL
begin
	drop function fr_wv_PagePrimaryTable;
end;
go
create function fr_wv_PagePrimaryTable
(
	@pagePart varchar(30)
)
returns varchar(30)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	declare @udt varchar(30),
		@page varchar(30);

	select @page = dbo.fr_BeforeDelimiter(@pagePart, '.');

	select @udt = gt.SUBSTITUTE
		from dbo.Gen_Tables gt
		join dbo.UD_Field uf
			on uf.TABLE_NAME = gt.SUBSTITUTE
		where gt.TABLE_NAME = 'CCW_PAGEPRIMARYTABLE'
			and gt.CODE = @page
			and uf.FIELD_NAME = 'SELECTOR_SINGLE';

	if @@rowcount = 0
	begin
		select @udt = gt.SUBSTITUTE
			from dbo.Gen_Tables gt
			where gt.TABLE_NAME = 'CCW_PAGEPRIMARYTABLE'
				and gt.CODE = @pagePart
				and gt.SUBSTITUTE not in (select TABLE_NAME from dbo.UD_Field uf where FIELD_NAME in ('SELECTOR_SINGLE', 'SELECTOR_MULTI'));
	end;

	return @udt;
end;
go
grant execute, references, view definition on dbo.fr_wv_PagePrimaryTable to IMIS;
grant execute, references, view definition on dbo.fr_wv_PagePrimaryTable to public;
go


print '-- pr_wv_SortCCW';
go
if object_id('pr_wv_SortCCW') is not NULL
begin
	drop procedure pr_wv_SortCCW;
end;
go
create procedure pr_wv_SortCCW
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	set nocount on;

	declare @lMaxSeqn int,
		@seqn int,
		@sortcount int,
		@part varchar(30),
		@lastpart varchar(30);

	create table #ConfigCategory
	(
		SEQN int identity(1,1),
		ORIG_SEQN int,
		PAGEPART varchar(30),
		SORT int,
		ORIG_SORT int
	);

	insert #ConfigCategory (ORIG_SEQN, PAGEPART, SORT, ORIG_SORT)
		select SEQN, PAGEPART, 0, SORT_POSITION
		from dbo.Config_Custom_Web
		order by PAGEPART, SORT_POSITION, SEQN;

	select @lMaxSeqn = max(SEQN)
		from #ConfigCategory;

	set @lastpart = '.';	-- Value not normally found in pagepart
	set @sortcount = 10;

	declare sortposition_cursor cursor fast_forward
	for
	select SEQN, PAGEPART
		from #ConfigCategory
		where ORIG_SORT != 0
			order by PAGEPART, ORIG_SORT;

	open sortposition_cursor;
	fetch next from sortposition_cursor
		into @seqn, @part;

	while @@fetch_status <> -1
	begin
		if @@fetch_status = 0
		begin
			if @part != @lastpart
			begin
				set @sortcount = 10;
				set @lastpart = @part;
			end;

			update #ConfigCategory
				set SORT = @sortcount
				where SEQN = @seqn;

			set @sortcount = @sortcount + 10;
		end;
		fetch next from sortposition_cursor
			into @seqn, @part;
	end;
	close sortposition_cursor;
	deallocate sortposition_cursor;

	if exists (select 1 from #ConfigCategory where SEQN != ORIG_SEQN or SORT != ORIG_SORT or SEQN > @lMaxSeqn)
	begin
		begin transaction;

		update dbo.Counter
			set LAST_VALUE = @lMaxSeqn,
				UPDATED_BY = 'pr_wv_SortCCW',
				LAST_UPDATED = getdate()
			where COUNTER_NAME = 'Config_Custom_Web';

		update cw
			set SEQN = cc.SEQN,
				SORT_POSITION = cc.SORT
			from #ConfigCategory cc
			join dbo.Config_Custom_Web cw
				on cw.SEQN = cc.ORIG_SEQN
			where (cc.SEQN != cc.ORIG_SEQN or cc.SORT != cc.ORIG_SORT);

		commit transaction;
	end;
end;
go
grant execute on dbo.pr_wv_SortCCW to IMIS;
go

print '-- vr_AllRelationships';
go
if object_id('vr_AllRelationships') is not NULL
begin
	drop view dbo.vr_AllRelationships;
end;
go
create view dbo.vr_AllRelationships
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
select ID, RELATION_TYPE, TARGET_ID, TARGET_NAME, TARGET_RELATION_TYPE, TITLE, FUNCTIONAL_TITLE, STATUS,
	EFFECTIVE_DATE, THRU_DATE, LAST_STRING, DATE_ADDED, LAST_UPDATED, UPDATED_BY, GROUP_CODE, SEQN, 'f' 'DIRECTION'
	from dbo.Relationship
union
select TARGET_ID, TARGET_RELATION_TYPE, ID, '', RELATION_TYPE, TITLE, FUNCTIONAL_TITLE, STATUS,
	EFFECTIVE_DATE, THRU_DATE, LAST_STRING, DATE_ADDED, LAST_UPDATED, UPDATED_BY, GROUP_CODE, SEQN, 'r'
	from dbo.Relationship
	where TARGET_ID > '';
go
grant select, insert, update, delete, references, view definition on dbo.vr_AllRelationships to IMIS;
grant select on dbo.vr_AllRelationships to public;
go



print '-- pr_wv_SaveRelationship';
go
if object_id('pr_wv_SaveRelationship') is not NULL
begin
	drop procedure pr_wv_SaveRelationship;
end;
go
create procedure pr_wv_SaveRelationship
	@lSeqn int = 0,
	@sId varchar(10),
	@sRelationType varchar(10),
	@sTargetId varchar(10),
	@sTargetName varchar(60),
	@sTargetRelationType varchar(10),
	@sTitle varchar(80),
	@sFunctionalTitle varchar(50),
	@sStatus varchar(5),
	@xEffectiveDate datetime,
	@xThruDate datetime,
	@tNote text,
	@sUser varchar(15),
	@sGroupCode varchar(30)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	set nocount on;

	declare @lReturnValue int,	-- 0 on success, number indicates error
		@sReturnMessage varchar(255),	-- output message, may be blank on success
		@xToday datetime,	-- Precalculated today's date with no time component
		@sOldId varchar(10),
		@sOldTargetId varchar(10),
		@sTemp varchar(10);

	-----------------------------------
	-- Setup initial values
	-----------------------------------
	set @lReturnValue = 0;	-- Assume success
	set @sReturnMessage = 'no error reported';
	set @xToday = convert(datetime, convert(varchar, getdate(), 112));

	-----------------------------------
	-- Validate inputs
	-----------------------------------

	if @sRelationType = ''
	begin
		set @lReturnValue = -1;
		set @sReturnMessage = 'Relationship type required.';
		goto finish;
	end;

	if @sTargetRelationType = ''
	begin
		set @lReturnValue = -2;
		set @sReturnMessage = 'Target relationship type required.';
		goto finish;
	end;

	if @sTargetId = '' and @sTargetName = ''
	begin
		set @lReturnValue = -3;
		set @sReturnMessage = 'Relationship must have target ID or target name.';
		goto finish;
	end;

	-----------------------------------
	-- Populate worktables with target data
	-----------------------------------

	if ltrim(@sUser) = ''
	begin
		set @sUser = user_name();
	end;

	-----------------------------------
	-- Apply data changes
	-----------------------------------

	if @lSeqn = 0
	begin
		update dbo.Counter
			set LAST_VALUE = LAST_VALUE + 1,
				@lSeqn = LAST_VALUE + 1,
				LAST_UPDATED = getdate(),
				UPDATED_BY = @sUser
			where COUNTER_NAME = 'Relationship';

		insert dbo.Relationship (SEQN, ID, RELATION_TYPE, TARGET_ID, TARGET_NAME, TARGET_RELATION_TYPE,
				TITLE, FUNCTIONAL_TITLE, STATUS, EFFECTIVE_DATE, THRU_DATE, NOTE, DATE_ADDED,
				UPDATED_BY, GROUP_CODE)
			values (@lSeqn, @sId, @sRelationType, @sTargetId, @sTargetName, @sTargetRelationType,
				@sTitle, @sFunctionalTitle, @sStatus, @xEffectiveDate, @xThruDate, @tNote, @xToday,
				@sUser, @sGroupCode);

		set @lReturnValue = @lSeqn;
	end
	else
	begin
		select @sOldId = ID,
				@sOldTargetId = TARGET_ID
			from dbo.Relationship r
			where SEQN = @lSeqn;

		-- if the old relationship had id/target reversed, then swap around.
		if (@sOldId != @sId and @sOldTargetId = @sId and @sTargetId != '')
		begin
			set @sTemp = @sId;
			set @sId = @sTargetId;
			set @sTargetId = @sTemp;

			set @sTemp = @sRelationType;
			set @sRelationType = @sTargetRelationType;
			set @sTargetRelationType = @sTemp;

			-- target name is no longer valid after reversing
			set @sTargetName = '';
		end;

		update dbo.Relationship
			set ID = @sId,
				RELATION_TYPE = @sRelationType,
				TARGET_ID = @sTargetId,
				TARGET_NAME = @sTargetName,
				TARGET_RELATION_TYPE = @sTargetRelationType,
				TITLE = @sTitle,
				FUNCTIONAL_TITLE = @sFunctionalTitle,
				STATUS = @sStatus,
				EFFECTIVE_DATE = @xEffectiveDate,
				THRU_DATE = @xThruDate,
				NOTE = @tNote,
				LAST_UPDATED = @xToday,
				UPDATED_BY = @sUser,
				GROUP_CODE = @sGroupCode
			where SEQN = @lSeqn;

		set @lReturnValue = @lSeqn;
	end;

	-----------------------------------
	-- Exit and return status
	-----------------------------------
finish:
	select @lReturnValue 'RETURN_VALUE', @sReturnMessage 'RETURN_MESSAGE';

	return @lReturnValue;
end;
go
grant execute on dbo.pr_wv_SaveRelationship to IMIS;
go


-- TODO Move fr_wv_RecordCanAddPage to McGladrey.Library?
print '-- fr_wv_RecordCanAddPage';
go
if object_id('fr_wv_RecordCanAddPage') is not NULL
begin
	drop function fr_wv_RecordCanAddPage;
end;
go
create function fr_wv_RecordCanAddPage
	(@sSelectedID varchar(10),
	@sPagePart varchar(30))
	returns varchar(10)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	declare @sReturn varchar(10),
			@sPrimaryTable varchar(30),
			@sEditType varchar(100),
			@bAllowEdit bit;

	set @bAllowEdit = 0;
	set @sEditType = '';

	select @sPrimaryTable = SUBSTITUTE
		from dbo.Gen_Tables
		where TABLE_NAME = 'CCW_PAGEPRIMARYTABLE'
			and CODE = @sPagePart;

	select @sEditType = EDIT_TYPES
		from dbo.UD_Table
		where TABLE_NAME = @sPrimaryTable;

	if @sEditType = ''
	begin
		set @bAllowEdit = 1;
	end
	else
	begin
		select @bAllowEdit = 1
			from dbo.fr_ListToRows(@sEditType) ltr
			join dbo.Name n
				on rtrim(ltrim(ltr.VALUE)) = n.MEMBER_TYPE
			where n.ID = @sSelectedID;
	end;

	return @bAllowEdit;
end;
go
grant execute, references, view definition on dbo.fr_wv_RecordCanAddPage to IMIS;
go

print '-- pr_wv_InsertSelectorDetail';
go
if object_id('pr_wv_InsertSelectorDetail') is not NULL
begin
	drop procedure pr_wv_InsertSelectorDetail;
end;
go
create procedure pr_wv_InsertSelectorDetail
	@plPageKey int,
	@psPageCode varchar(30)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	set nocount on;

	declare @sGuid varchar(36);

	-- clean out records over a day old
	delete dbo.tr_wv_SelectorDetail
		where DATE_ADDED < dateadd(day, -1, getdate());

	set @sGuid = newid();

	insert dbo.tr_wv_SelectorDetail (DETAIL_KEY, PAGE_KEY, PAGE_CODE)
		values(@sGuid, @plPageKey, @psPageCode);

	select @sGuid 'CURRENT_GUID';

	return 0;
end;
go
grant execute, view definition on dbo.pr_wv_InsertSelectorDetail to IMIS;
go


print '-- pr_wv_UnmetRequirements';
go
if object_id('pr_wv_UnmetRequirements') is not NULL
begin
	drop procedure pr_wv_UnmetRequirements;
end;
go
create procedure pr_wv_UnmetRequirements
	@psLoggedInID varchar(10),
	@psSelectedID varchar(10),
	@psPageCode varchar(30),
	@plPageKey int,
	@pbIsNew bit
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	set nocount on;

	declare @lModuleAccess int,
		@sTableName varchar(30),
		@sFieldName varchar(30),
		@sFieldType varchar(10),
		@sRolesView varchar(255),
		@sRolesEdit varchar(255),
		@sSelector varchar(50),
		@bViewable bit,
		@bEditable bit,
		@sSQL varchar(max),
		@unmet bit;

	set @lModuleAccess = 0;

	declare @UserRoles table
	(
		Role nvarchar(50)
	);

	create table #UnmetReq
	(
		UNMET_REQ bit
	);

	insert #UnmetReq (UNMET_REQ)
		values (0);

	select @lModuleAccess = u.LevelMembership
		from dbo.UserMain um
		join dbo.Users u
			on u.UserId = um.UserId
		where um.ContactMaster = @psLoggedInID;

	if @lModuleAccess < 3
	begin
		update #UnmetReq
			set UNMET_REQ = 0;

		goto finish;
	end;

	select @sSelector = dbo.fr_wv_SeqnToSelector(@plPageKey, @psPageCode);

	insert @UserRoles (Role)
		select rm.Name
		from dbo.RoleMain rm
		join dbo.UserRole ur
			on ur.RoleKey = rm.RoleKey
		join dbo.UserMain um
			on um.UserKey = ur.UserKey
		where um.ContactMaster = @psLoggedInID;

	declare @tSingleInstance table (TABLE_NAME varchar(30));

	insert @tSingleInstance (TABLE_NAME)
		select distinct TABLE_NAME
		from dbo.UD_Field
		where FIELD_NAME = 'SELECTOR_SINGLE';

	if @pbIsNew = 1
	begin
		declare field_cursor cursor fast_forward
		for
		select ccw.DEMOG_TABLE_NAME, ccw.FIELD_NAME, udf.FIELD_TYPE, ROLES_REQUIRED_VIEW_NEW, ROLES_REQUIRED_EDIT_NEW
			from dbo.Config_Custom_Web ccw
			join dbo.UD_Field udf
				on udf.TABLE_NAME = ccw.DEMOG_TABLE_NAME
				and udf.FIELD_NAME = ccw.FIELD_NAME
			where PAGEPART like @psPageCode + '.%'
				and SORT_POSITION > 0
				and FIELD_REQUIRED = 1
				and VALIDATION_TYPE <> 'SQLFUNCTION'
				and TABLE_NAME in (select si.TABLE_NAME from @tSingleInstance si)
			order by ccw.DEMOG_TABLE_NAME;
	end
	else
	begin
		declare field_cursor cursor fast_forward
		for
		select ccw.DEMOG_TABLE_NAME, ccw.FIELD_NAME, udf.FIELD_TYPE, ROLES_REQUIRED_VIEW, ROLES_REQUIRED_EDIT
			from dbo.Config_Custom_Web ccw
			join dbo.UD_Field udf
				on udf.TABLE_NAME = ccw.DEMOG_TABLE_NAME
				and udf.FIELD_NAME = ccw.FIELD_NAME
			where PAGEPART like @psPageCode + '.%'
				and SORT_POSITION > 0
				and FIELD_REQUIRED = 1
				and VALIDATION_TYPE <> 'SQLFUNCTION'
				and TABLE_NAME in (select si.TABLE_NAME from @tSingleInstance si)
			order by ccw.DEMOG_TABLE_NAME;
	end;

	open field_cursor;
	fetch next from field_cursor
		into @sTableName, @sFieldName, @sFieldType, @sRolesView, @sRolesEdit;

	while @@fetch_status <> -1
	begin
		if @@fetch_status = 0
		begin
			set @bViewable = 0;
			set @bEditable = 0;

			if @sRolesView = ''
			begin
				set @bViewable = 1;
			end
			else
			begin
				select @bViewable = 1
					from @UserRoles ur
					join dbo.fr_ListToRows(@sRolesView) ltr
						on ur.Role = rtrim(ltrim(ltr.VALUE));
			end;

			if @bViewable = 1
			begin
				if @sRolesEdit = ''
				begin
					set @bEditable = 1;
				end;
				else
				begin
					select @bEditable = 1
						from @UserRoles ur
						join dbo.fr_ListToRows(@sRolesEdit) ltr
							on ur.Role = rtrim(ltrim(ltr.VALUE));
				end;
			end;

			if @bEditable = 1
			begin
				set @sSQL = 'update #UnmetReq set UNMET_REQ = 1
							from dbo.' + @sTableName +
							' where ID = ''' + @psSelectedID + ''''
							+ ' and SELECTOR_SINGLE = ''' + @sSelector + '''';

				if @sFieldType = 'Char'
				begin
					select @sSQL = @sSQL + ' and convert(varchar(max), ' + @sFieldName + ') = ''''';
				end;
				else if @sFieldType = 'Date'
				begin
					select @sSQL = @sSQL + ' and ' + @sFieldName + ' is null';
				end;
				else if @sFieldType = 'Time'
				begin
					select @sSQL = @sSQL + ' and ' + @sFieldName + ' is null or ' + @sFieldName + ' = ''1900-01-01 00:00:00.000''';
				end;
				else if @sFieldType in ('Int', 'Money', 'Number')
				begin
					select @sSQL = @sSQL + ' and ' + @sFieldName + ' = 0';
				end;

				exec (@sSQL);

				if (select UNMET_REQ from #UnmetReq) = 1
				begin
					close field_cursor;
					deallocate field_cursor;

					goto finish;
				end;
			end;
		end;
		fetch next from field_cursor
			into @sTableName, @sFieldName, @sFieldType, @sRolesView, @sRolesEdit;
	end;
	close field_cursor;
	deallocate field_cursor;

finish:
	select @unmet = UNMET_REQ
		from #UnmetReq;

	return @unmet;
end;
go
grant execute, view definition on dbo.pr_wv_UnmetRequirements to IMIS;
go

print '-- pr_wv_WriteLog';
go
if object_id('pr_wv_WriteLog') is not NULL
begin
	drop procedure pr_wv_WriteLog;
end;
go
create procedure pr_wv_WriteLog
	@level int,
	@message varchar(8000)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	set nocount on;

	declare @maxLevel int,
		@maxLevelStr varchar(255);

	set @maxLevel = 3;	-- fallback value

	if exists (select 1 from dbo.sysobjects where name = 'SystemConfig')
	begin
		select @maxLevelStr = ParameterValue
			from dbo.SystemConfig
			where ParameterName = 'RSM.Common.LogLevel';

		if @@rowcount != 0
		begin
			if isnumeric(@maxLevelStr) = 1
			begin
				set @maxLevel = convert(int, @maxLevelStr);
			end;
		end;
	end;

	if @maxLevel < 0 or @maxLevel > 5
	begin
		set @maxLevel = 3;
	end;

	if @level <= @maxlevel
	begin
		insert dbo.tr_wv_Log (CONFIG_LOG_LEVEL, CURRENT_LOG_LEVEL, LOG_TEXT)
			values (@maxLevel, @level, @message);
	end;
end;
go
grant execute, view definition on dbo.pr_wv_WriteLog to public;
go

print 'Creating procedure pr_wv_InternalCreateInstance';
go
if object_id('pr_wv_InternalCreateInstance') is not NULL
begin
	drop procedure pr_wv_InternalCreateInstance;
end;
go
create procedure pr_wv_InternalCreateInstance
(
	@id varchar(10),
	@thisTable varchar(30),
	@newSelector varchar(50),
	@currentSelector varchar(50),
	@selectorType varchar(10),
	@debug bit = 0,
	@loggedInID varchar(10) = '',
	@insertLogging bit = 0
)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @newSeqn int,
		@cmd nvarchar(4000);

	insert dbo.Counter (COUNTER_NAME, LAST_VALUE, HAS_CHECKSUM)
		select @thisTable, 0, 0
		where not exists (select 1 from dbo.Counter where COUNTER_NAME = @thisTable);

	if @selectorType = 'SINGLE'
	begin
		set @cmd = N'
if not exists (select 1 from dbo.' + quotename(@thisTable) + N' where ID = @paramId and SELECTOR_SINGLE = @paramMySelector and SELECTOR_PARENT = @paramParentSelector)
begin
  update dbo.Counter
    set LAST_VALUE = LAST_VALUE + 1,
      @paramSeqn = LAST_VALUE + 1,
      LAST_UPDATED = getdate(),
      UPDATED_BY = ''CreateInstance''
      where COUNTER_NAME = ''' + @thisTable + N''';
  insert dbo.' + quotename(@thisTable) + N' (ID, SEQN, SELECTOR_SINGLE, SELECTOR_PARENT)
    select @paramId, @paramSeqn, @paramMySelector, @paramParentSelector
    where not exists (select 1 from dbo.' + quotename(@thisTable) + N' where ID = @paramId and SELECTOR_SINGLE = @paramMySelector and SELECTOR_PARENT = @paramParentSelector);
  insert dbo.Name_Log (DATE_TIME, LOG_TYPE, SUB_TYPE, USER_ID, ID, LOG_TEXT)
  	select getdate(), ''CHANGE'', ''ADD'', @paramloggedInID, @paramId, ''' +  @thisTable + N': SEQN -> '' + ' +
  		N'convert(varchar, @paramSeqn) + ''; SELECTOR_SINGLE -> '' + @paramMySelector + ''; SELECTOR_PARENT -> '' + @paramParentSelector
  	where @paraminsertLogging = 1;
end';

		if @debug = 1
		begin
			print @cmd;
		end;

		exec dbo.sp_executesql @cmd,
			N'@paramId varchar(10), @paramSeqn int output, @paramMySelector varchar(50), @paramParentSelector varchar(50), @paramloggedInID varchar(10), @paraminsertLogging bit',
			@paramId = @id, @paramSeqn = @newSeqn output, @paramMySelector = @newSelector, @paramParentSelector = @currentSelector, @paramloggedInID = @loggedInID, @paraminsertLogging = @insertLogging;
	end
	else if @selectorType = 'MULTI'
	begin
		set @cmd = N'
  update dbo.Counter
    set LAST_VALUE = LAST_VALUE + 1,
      @paramSeqn = LAST_VALUE + 1,
      LAST_UPDATED = getdate(),
      UPDATED_BY = ''CreateInstance''
      where COUNTER_NAME = ''' + @thisTable + N'''
  insert dbo.' + quotename(@thisTable) + N' (ID, SEQN, SELECTOR_MULTI, SELECTOR_PARENT)
    select @paramId, @paramSeqn, @paramMySelector, @paramParentSelector';

		if @debug = 1
		begin
			print @cmd;
		end;

		exec dbo.sp_executesql @cmd,
			N'@paramId varchar(10), @paramSeqn int output, @paramMySelector varchar(50), @paramParentSelector varchar(50)',
			@paramId = @id, @paramSeqn = @newSeqn output, @paramMySelector = @newSelector, @paramParentSelector = @currentSelector;
	end
	else if @selectorType = 'SIMPLE'
	begin
		set @cmd = N'
update dbo.Counter
  set LAST_VALUE = LAST_VALUE + 1,
    @paramSeqn = LAST_VALUE + 1,
    LAST_UPDATED = getdate(),
    UPDATED_BY = ''CreateInstance''
  where COUNTER_NAME = ''' + @thisTable + N'''
insert dbo.' + quotename(@thisTable) + N' (ID, SEQN)
  select @paramId, @paramSeqn
  where not exists (select 0 from dbo.' + quotename(@thisTable) + N' where ID = @paramId and SEQN = @paramSeqn)';

		if @debug = 1
		begin
			print @cmd;
		end;

		exec dbo.sp_executesql @cmd,
			N'@paramId varchar(10), @paramSeqn int output',
			@paramId = @id, @paramSeqn = @newSeqn output;
	end;

	if @newSeqn = 0
	begin
		set @newSeqn = -20;
	end;

finish:
	return @newSeqn;
end;
go
grant execute, view definition on dbo.pr_wv_InternalCreateInstance to IMIS;
grant execute, view definition on dbo.pr_wv_InternalCreateInstance to public;
go

print 'Creating procedure pr_wv_SetDefaultValues';
go
if object_id('pr_wv_SetDefaultValues') is not NULL
begin
	drop procedure pr_wv_SetDefaultValues;
end;
go
create procedure pr_wv_SetDefaultValues
(
	@newSeqn int,
	@id varchar(10),
	@thisTable varchar(30),
	@page varchar(30),
	@debug bit = 0
)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @lReturnValue int,	-- 0 on success, number indicates error
		@cmd nvarchar(4000),
		@field varchar(30),
		@formula varchar(100);

	set @lReturnValue = 0;	-- Assume success

	declare FieldsWithDefault_cursor cursor fast_forward
	for
	select distinct ccw.FIELD_NAME, ccw.DEFAULT_VALUE_FUNCTION
		from dbo.Config_Custom_Web ccw
		where DEMOG_TABLE_NAME = @thisTable
			and PAGEPART like @page + '.%'
			and DEFAULT_VALUE_FUNCTION != ''
			and SORT_POSITION != 0
		order by ccw.FIELD_NAME;

	open FieldsWithDefault_cursor;
	fetch next from FieldsWithDefault_cursor
		into @field, @formula;

	while @@fetch_status <> -1
	begin
		if @@fetch_status = 0
		begin
			if @formula not like '%.%'
			begin
				set @formula = 'dbo.' + @formula;
			end;

			set @cmd = N'update dbo.' + quotename(@thisTable)
				+ N' set ' + quotename(@field) + N' = ' + @formula + N'(SEQN)'
				+ N' where SEQN = @paramSeqn and ID = @paramId';

			if @debug = 1
			begin
				print @cmd;
			end;

			exec dbo.sp_executesql @cmd,
				N'@paramSeqn int, @paramId varchar(10)',
				@paramSeqn = @newSeqn, @paramId = @id;;
		end;
		fetch next from FieldsWithDefault_cursor
			into @field, @formula;
	end;
	close FieldsWithDefault_cursor;
	deallocate FieldsWithDefault_cursor;


	-----------------------------------
	-- Exit and return status
	-----------------------------------
finish:
	return @lReturnValue;
end;
go
grant execute, view definition on dbo.pr_wv_SetDefaultValues to IMIS;
grant execute, view definition on dbo.pr_wv_SetDefaultValues to public;
go


print 'Creating procedure pr_wv_CreateInstance';
go
if object_id('pr_wv_CreateInstance') is not NULL
begin
	drop procedure pr_wv_CreateInstance;
end;
go
create procedure pr_wv_CreateInstance
(
	@id varchar(10),
	@pagePart varchar(30),
	@newSelector varchar(50),
	@currentPageKey int,
	@currentPageCode varchar(30),
	@debug bit = 0,
	@loggedInID varchar(10) = '',
	@insertLogging bit = 0
)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @lReturnValue int,	-- 0 on success, number indicates error
		@xToday datetime,	-- Precalculated today's date with no time component
		@page varchar(30),
		@keyTable varchar(30),
		@currentSelector varchar(50),
		@thisTable varchar(30),
		@newSeqn int,
		@cmd nvarchar(4000),
		@newSubStatus varchar(30),
		@keySeqn int,
		@sCustomCmd nvarchar(1000);

	-----------------------------------
	-- Setup initial values
	-----------------------------------
	set @lReturnValue = 0; -- Assume failure
	set @xToday = convert(datetime, convert(varchar, getdate(), 112));
	set @keySeqn = -1;

	-----------------------------------
	-- Validate inputs
	-----------------------------------

	select @page = dbo.fr_BeforeDelimiter(@pagePart, '.');

	select @keyTable = dbo.fr_wv_PagePrimaryTable(@page);

	if @@rowcount != 1
	begin
		set @lReturnValue = -10;
		goto finish;
	end;

	set @currentSelector = '';

	if @currentPageKey > 0
	begin
		select @currentSelector = dbo.fr_wv_SeqnToSelector(@currentPageKey, @currentPageCode);

		if @currentSelector = ''
		begin
			set @lReturnValue = -15;
			goto finish;
		end;
	end;

	-----------------------------------
	-- Iterate over applicable tables
	-----------------------------------
	declare pageTables_cursor cursor fast_forward
	for
	select distinct ut.TABLE_NAME
		from dbo.Config_Custom_Web ccw
		join dbo.UD_Table ut
			on ut.TABLE_NAME = ccw.DEMOG_TABLE_NAME
		join dbo.UD_Field uf
			on uf.TABLE_NAME = ut.TABLE_NAME
			and uf.TABLE_NAME = ccw.DEMOG_TABLE_NAME
		join dbo.UD_Field ufp
			on ufp.TABLE_NAME = ut.TABLE_NAME
			and ufp.TABLE_NAME = ccw.DEMOG_TABLE_NAME
		where ccw.PAGEPART like @page + '.%'
			and ut.ALLOW_MULTIPLE_INSTANCES = 1
			and uf.FIELD_NAME = 'SELECTOR_SINGLE'
			and ufp.FIELD_NAME = 'SELECTOR_PARENT'
		order by ut.TABLE_NAME;

	open pageTables_cursor;
	fetch next from pageTables_cursor
		into @thisTable;

	while @@fetch_status <> -1
	begin
		if @@fetch_status = 0
		begin
			exec @newSeqn = dbo.pr_wv_InternalCreateInstance @id, @thisTable, @newSelector, @currentSelector, 'SINGLE', @debug, @loggedInID, @insertLogging;

			if @newSeqn < 0 and @lReturnValue = 0
			begin
				set @lReturnValue = @newSeqn;
			end;
			else
			begin
				if @thisTable = @keyTable
				begin
					set @keySeqn = @newSeqn;

					-- Set SUBMISSION_STATUS to first item in lookup if present
					set @newSubStatus = '';

					select @newSubStatus = min(gt.CODE)
						from dbo.Gen_Tables gt
						join dbo.Config_Custom_Web ccw
							on ccw.VALIDATION_TABLE = gt.TABLE_NAME
						where ccw.DEMOG_TABLE_NAME = @thisTable
							and ccw.FIELD_NAME = 'SUBMISSION_STATUS'
							and ccw.VALIDATION_TABLE != ''
							and gt.CODE != '';

					if isnull(@newSubStatus, '') != ''
					begin
						set @cmd = N'update dbo.' + quotename(@thisTable)
							+ N' set SUBMISSION_STATUS = @paramStatus where ID = @paramId and SEQN = @paramSeqn';

						if @debug = 1
						begin
							print @cmd;
						end;

						exec dbo.sp_executesql @cmd,
							N'@paramStatus varchar(30), @paramId varchar(10), @paramSeqn int',
							@paramStatus = @newSubStatus, @paramId = @id, @paramSeqn = @newSeqn;
					end;

				end;

				exec dbo.pr_wv_SetDefaultValues @newSeqn, @id, @thisTable, @page, @debug;
			end;
		end;
		fetch next from pageTables_cursor
			into @thisTable;
	end;
	close pageTables_cursor;
	deallocate pageTables_cursor;

	if exists (select 1 from sys.procedures where name = 'pr_wv_CreateInstance_Custom')
	begin
		set @sCustomCmd = N'exec dbo.pr_wv_CreateInstance_Custom @paramid, @paramPagePart,'
						+ N' @paramNewPageKey, @paramCurrentPageKey, @paramCurrentPageCode, @paramDebug, '
						+ N' @paramLoggedInID, @paramInsertLogging, @paramSelector';

		if @debug = 1
		begin
			print @sCustomCmd;
		end;

		exec dbo.sp_executesql @sCustomCmd,
			N'@paramid varchar(10), @paramPagePart varchar(30), @paramNewPageKey int, @paramCurrentPageKey int, @paramCurrentPageCode varchar(30), @paramDebug bit, @paramLoggedInID varchar(10), @paramInsertLogging bit, @paramSelector varchar(50)',
			@paramid = @id, @paramPagePart = @pagePart, @paramNewPageKey = @keySeqn,
			@paramCurrentPageKey = @currentPageKey, @paramCurrentPageCode = @currentPageCode,
			@paramDebug = @debug, @paramLoggedInID = @loggedInID, @paramInsertLogging = @insertLogging,
			@paramSelector = @newSelector;
	end;

	if @lReturnValue = 0 and @keySeqn >= 0
	begin
		set @lReturnValue = @keySeqn;
	end;

	-----------------------------------
	-- Exit and return status
	-----------------------------------
finish:
	return @lReturnValue;
end;
go
grant execute, view definition on dbo.pr_wv_CreateInstance to IMIS;
grant execute, view definition on dbo.pr_wv_CreateInstance to public;
go


print 'Creating procedure pr_wv_CreateInstanceAutoSelector';
go
if object_id('pr_wv_CreateInstanceAutoSelector') is not NULL
begin
	drop procedure pr_wv_CreateInstanceAutoSelector;
end;
go
create procedure pr_wv_CreateInstanceAutoSelector
(
	@id varchar(10),
	@pagePart varchar(30),
	@currentPageKey int,
	@currentPageCode varchar(30),
	@debug bit = 0,
	@loggedInID varchar(10) = '',
	@insertLogging bit = 0
)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @lReturnValue int,
		@page varchar(30),
		@newSelector varchar(50);

	set @lReturnValue = -1;

	select @page = dbo.fr_BeforeDelimiter(@pagePart, '.');

	set @newSelector = @page + '.' + replace(newid(), '-', '');

	exec @lReturnValue = dbo.pr_wv_CreateInstance @id, @pagePart, @newSelector, @currentPageKey,
			@currentPageCode, @debug, @loggedInID, @insertLogging;

	return @lReturnValue;
end;
go
grant execute, view definition on dbo.pr_wv_CreateInstanceAutoSelector to IMIS;
grant execute, view definition on dbo.pr_wv_CreateInstanceAutoSelector to public;
go


print 'Creating procedure pr_wv_CreateMultiInstance';
go
if object_id('pr_wv_CreateMultiInstance') is not NULL
begin
	drop procedure pr_wv_CreateMultiInstance;
end;
go
create procedure pr_wv_CreateMultiInstance
(
	@id varchar(10),
	@pagePart varchar(30),
	@selector varchar(50),
	@debug bit = 0
)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @lReturnValue int,	-- 0 on success, number indicates error
		@thisTable varchar(30),
		@page varchar(30);

	-----------------------------------
	-- Setup initial values
	-----------------------------------
	set @lReturnValue = -1;	-- Assume failure

	select @page = dbo.fr_BeforeDelimiter(@pagePart, '.');


	-----------------------------------
	-- Validate inputs
	-----------------------------------

	select @thisTable = max(ut.TABLE_NAME)
		from dbo.Config_Custom_Web ccw
		join dbo.UD_Table ut
			on ut.TABLE_NAME = ccw.DEMOG_TABLE_NAME
		join dbo.UD_Field uf
			on uf.TABLE_NAME = ut.TABLE_NAME
			and uf.TABLE_NAME = ccw.DEMOG_TABLE_NAME
		where ccw.PAGEPART = @pagePart
			and ut.ALLOW_MULTIPLE_INSTANCES = 1
			and uf.FIELD_NAME = 'SELECTOR_MULTI';

	if @@rowcount != 1
	begin
		set @lReturnValue = -10;
		goto finish;
	end;

 	-- TODO Grid view does not currently support nesting, but maybe it should
	exec @lReturnValue = dbo.pr_wv_InternalCreateInstance @id, @thisTable, @selector, '', 'MULTI', @debug;

	if @lReturnValue > 0
	begin
		exec dbo.pr_wv_SetDefaultValues @lReturnValue, @id, @thisTable, @page, @debug;
	end;

	-----------------------------------
	-- Exit and return status
	-----------------------------------
finish:
	return @lReturnValue;
end;
go
grant execute, view definition on dbo.pr_wv_CreateMultiInstance to IMIS;
grant execute, view definition on dbo.pr_wv_CreateMultiInstance to public;
go

print 'Creating procedure pr_wv_CreateSimpleMultiInstance';
go
if object_id('pr_wv_CreateSimpleMultiInstance') is not NULL
begin
	drop procedure pr_wv_CreateSimpleMultiInstance;
end;
go
create procedure pr_wv_CreateSimpleMultiInstance
(
	@id varchar(10),
	@pagePart varchar(30),
	@debug bit = 0
)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @lReturnValue int,	-- 0 on success, number indicates error
		@thisTable varchar(30),
		@page varchar(30);

	-----------------------------------
	-- Setup initial values
	-----------------------------------
	set @lReturnValue = -1;	-- Assume failure

	select @page = dbo.fr_BeforeDelimiter(@pagePart, '.');

	-----------------------------------
	-- Validate inputs
	-----------------------------------

	select @thisTable = max(ut.TABLE_NAME)
		from dbo.Config_Custom_Web ccw
		join dbo.UD_Table ut
			on ut.TABLE_NAME = ccw.DEMOG_TABLE_NAME
		where ccw.PAGEPART = @pagePart
			and ut.ALLOW_MULTIPLE_INSTANCES = 1
			and ut.TABLE_NAME not in (select uf.TABLE_NAME
					from dbo.UD_Field uf
					where uf.FIELD_NAME in ('SELECTOR_SINGLE', 'SELECTOR_MULTI'));

	if @@rowcount != 1
	begin
		set @lReturnValue = -10;
		goto finish;
	end;

	-- Simple view does not support nesting by design
	exec @lReturnValue = dbo.pr_wv_InternalCreateInstance @id, @thisTable, '', '', 'SIMPLE', @debug;

	if @lReturnValue > 0
	begin
		exec dbo.pr_wv_SetDefaultValues @lReturnValue, @id, @thisTable, @page, @debug;
	end;

	-----------------------------------
	-- Exit and return status
	-----------------------------------
finish:
	return @lReturnValue;
end;
go
grant execute, view definition on dbo.pr_wv_CreateSimpleMultiInstance to IMIS;
grant execute, view definition on dbo.pr_wv_CreateSimpleMultiInstance to public;
go


print 'Creating procedure pr_wv_UDTableToCCW';
go
if object_id('pr_wv_UDTableToCCW') is not NULL
begin
	drop procedure pr_wv_UDTableToCCW;
end;
go
create procedure pr_wv_UDTableToCCW
	@psUDTable varchar(30),
	@psPagePart varchar(30)
as
/***************************************************************************************************
	 2016 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/wvSuite/trunk/SQL/wvSuite_Install.3.sql $
$Rev: 11628 $
$Date: 2017-02-15 17:26:07 -0600 (Wed, 15 Feb 2017) $
***************************************************************************************************/
-- Generate a new page code and CCW group from a UDT
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @pagecode varchar(30),
		@newpage bit,
		@ownerId varchar(10),
		@primaryTable varchar(30)

	-----------------------------------
	-- Validate inputs
	-----------------------------------

	-- Make sure the lookup contains all known MI UDTs as a courtesy
	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
		select 'CCW_MULTI_UDTS', udt.TABLE_NAME, upper(udt.TABLE_NAME), udt.TABLE_NAME
		from dbo.UD_Table udt
		where ALLOW_MULTIPLE_INSTANCES = 1
			and udt.TABLE_NAME not in (select CODE from dbo.Gen_Tables where TABLE_NAME = 'CCW_MULTI_UDTS');

	select @ownerId = sc.ParameterValue
		from dbo.SystemConfig sc
		join dbo.Name n
			on n.ID = sc.ParameterValue
		where sc.ParameterName = 'RSM.wvMultiInstance.ConfigurationOwner'
			and n.MEMBER_TYPE = '_CFG'

	if @@rowcount = 0
	begin
		print 'Error: The Configuration Owner setting is not defined, does not exist, or has the wrong member type.'
		return;
	end

	-- Ensure the counter is correct
	update dbo.Counter
		set LAST_VALUE = (select max(SEQN) from dbo.Config_Custom_Web where ID = @ownerId)
		where COUNTER_NAME = 'Config_Custom_Web'

	if @psUDTable not in (select CODE from dbo.Gen_Tables where TABLE_NAME = 'CCW_MULTI_UDTS')
	begin
		print 'Error: @psTable must be a known User-Defined Table that allows multiple instances';
		return;
	end

	-- Normalize the name of the table
	select @psUDTable = udt.TABLE_NAME
		from dbo.UD_Table udt
		where udt.TABLE_NAME = @psUDTable

	if charindex('.', @psPagePart) in (0, 1, len(@psPagePart))
	begin
		print 'Error: @psPagepart must be of the form PAGE.PART';
		return;
	end;

	set @pagecode = left(@psPagePart, charindex('.', @psPagePart) - 1)

	if exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'CCW_PAGEPART' and CODE = @psPagePart)
	begin
		print 'Error: Gen_Tables CCW_PAGEPART already contains an entry for PagePart ' + @psPagePart;
		return;
	end;

	if exists (select 1 from dbo.Config_Custom_Web where PAGEPART = @psPagePart)
	begin
		print 'Error: Config_Custom_Web already contains one or more entries for PagePart ' + @psPagepart;
		return;
	end;

	select @primaryTable = SUBSTITUTE
		from dbo.Gen_Tables
		where TABLE_NAME = 'CCW_PAGEPRIMARYTABLE'
			and CODE = @pagecode

	if isnull(@primaryTable, '') != ''
	begin
		print 'Pagecode ' + @pagecode + ' already exists with ' + @primaryTable + ' as the primary table.  Adding as a new part on the same page.';
		set @newpage = 0
	end
	else
	begin
		print 'Pagecode ' + @pagecode + ' does not exist.  ' + @psUDTable + ' will be the primary table for this page.';
		set @newpage = 1
		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE)
			values ('CCW_PAGEPRIMARYTABLE', @pagecode, upper(@pagecode), @psUDTable)
	end

	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
		values ('CCW_PAGEPART', @psPagePart, upper(@psPagePart), @psPagePart + ' (autogenerated ' + convert(varchar(30), getdate(), 109) + ')')

	declare @counter_rows int,
		@counter_seqn int;

	declare @udf_numbered table
	(
		SEQN int identity,
		UNIQUE_KEY int not NULL,
		NEW_SEQN int
	);

	insert @udf_numbered (UNIQUE_KEY, NEW_SEQN)
		select SEQ, 0
		from dbo.UD_Field udf
		where udf.TABLE_NAME = @psUDTable
		order by SEQ

	select @counter_rows = count(*)
		from @udf_numbered;

	update dbo.Counter
		set LAST_VALUE = LAST_VALUE + @counter_rows,
			@counter_seqn = LAST_VALUE,
			LAST_UPDATED = getdate(),
			UPDATED_BY = user_name()
		where COUNTER_NAME = 'Config_Custom_Web';

	update xn
		set NEW_SEQN = xn.SEQN + @counter_seqn
		from @udf_numbered xn

	insert dbo.Config_Custom_Web (ID, SEQN, DEMOG_TABLE_NAME, FIELD_NAME, PAGEPART, PROMPT, SORT_POSITION, VALIDATION_TABLE, VALIDATION_TYPE, ROLES_REQUIRED_EDIT, ROLES_REQUIRED_EDIT_NEW)
		select @ownerId, un.NEW_SEQN, @psUDTable, udf.FIELD_NAME, @psPagePart, udf.PROMPT, udf.SEQ * 10, udf.VALIDATION_TABLE,
			-- Flag the field as having a lookup table if defined
			case udf.VALIDATION_TABLE when '' then '' else 'GENTABLE' end,
			-- Selector fields are automatically read-only
			case when udf.FIELD_NAME in ('SELECTOR_SINGLE', 'SELECTOR_MULTI', 'SELECTOR_PARENT') then 'NOBODY' else '' end,
			case when udf.FIELD_NAME in ('SELECTOR_SINGLE', 'SELECTOR_MULTI', 'SELECTOR_PARENT') then 'NOBODY' else '' end
		from dbo.UD_Field udf
		join @udf_numbered un
			on udf.SEQ = un.UNIQUE_KEY
		where udf.TABLE_NAME = @psUDTable

	print 'Success:  new PagePart created.'
end;
go
grant execute, view definition on dbo.pr_wv_UDTableToCCW to IMIS;
go

go
print '';
print @@servername + ':' + db_name() + ' - finished at ' + convert(varchar(30), getdate(), 109);
print '';
go